gtkmm: Gtk::PlacesSidebar Class Reference

gtkmm 3.24.0

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gtk::PlacesSidebar Class Reference
Widgets

Sidebar that displays frequently-used places in the file system. More...

`#include <gtkmm/placessidebar.h>`

Inheritance diagram for Gtk::PlacesSidebar:
[legend]

## Public Member Functions
| PlacesSidebar (PlacesSidebar&& src) noexcept
PlacesSidebar& | operator= (PlacesSidebar&& src) noexcept
| PlacesSidebar (const PlacesSidebar&)=delete
PlacesSidebar& | operator= (const PlacesSidebar&)=delete
| ~PlacesSidebar () noexcept override
GtkPlacesSidebar* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkPlacesSidebar* | gobj () const
| Provides access to the underlying C GObject. More...
| PlacesSidebar ()
| Creates a new Gtk::PlacesSidebar widget. More...
void | set_open_flags (PlacesOpenFlags flags=PLACES_OPEN_NORMAL)
| Sets the way in which the calling application can open new locations from the places sidebar. More...
PlacesOpenFlags | get_open_flags () const
| Gets the open flags. More...
void | set_location (const Glib::RefPtr< const Gio::File >& location)
| Sets the location that is being shown in the widgets surrounding the sidebar, for example, in a folder view in a file manager. More...
Glib::RefPtr< Gio::File > | get_location () const
| Gets the currently selected location in the sidebar. More...
void | set_show_desktop (bool show_desktop=true)
| Sets whether the sidebar should show an item for the Desktop folder. More...
bool | get_show_desktop () const
| Returns the value previously set with set_show_desktop() More...
void | add_shortcut (const Glib::RefPtr< Gio::File >& location)
| Applications may want to present some folders in the places sidebar if they could be immediately useful to users. More...
void | remove_shortcut (const Glib::RefPtr< Gio::File >& location)
| Removes an application-specific shortcut that has been previously been inserted with add_shortcut(). More...
std::vector< Glib::RefPtr< Gio::File > > | list_shortcuts () const
| Gets the list of shortcuts. More...
Glib::RefPtr< Gio::File > | get_nth_bookmark (int n) const
| This function queries the bookmarks added by the user to the places sidebar, and returns one of them. More...
void | set_show_connect_to_server (bool show_connect_to_server=true)
| Sets whether the sidebar should show an item for connecting to a network server; this is off by default. More...
bool | get_show_connect_to_server () const
| Returns the value previously set with set_show_connect_to_server() More...
void | set_local_only (bool local_only=true)
| Sets whether the sidebar should only show local files. More...
bool | get_local_only () const
| Returns the value previously set with set_local_only(). More...
void | set_show_enter_location (bool show_enter_location=true)
| Sets whether the sidebar should show an item for entering a location; this is off by default. More...
bool | get_show_enter_location () const
| Returns the value previously set with set_show_enter_location() More...
void | set_show_recent (bool show_recent=true)
| Sets whether the sidebar should show an item for recent files. More...
bool | get_show_recent () const
| Returns the value previously set with set_show_recent() More...
void | set_show_trash (bool show_trash=true)
| Sets whether the sidebar should show an item for the Trash location. More...
bool | get_show_trash () const
| Returns the value previously set with set_show_trash() More...
void | set_show_other_locations (bool show_other_locations=true)
| Sets whether the sidebar should show an item for the application to show an Other Locations view; this is off by default. More...
bool | get_show_other_locations () const
| Returns the value previously set with set_show_other_locations() More...
void | set_drop_targets_visible (bool visible, const Glib::RefPtr< Gdk::DragContext >& context)
| Make the GtkPlacesSidebar show drop targets, so it can show the available drop targets and a "new bookmark" row. More...
Glib::SignalProxy< int, const Glib::RefPtr< Gdk::DragContext >&, const Glib::RefPtr< Gio::File >&, const std::vector< Glib::RefPtr< Gio::File > >& > | signal_drag_action_requested ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::File >&, const std::vector< Glib::RefPtr< Gio::File > >&, int > | signal_drag_perform_drop ()
Glib::SignalProxy< int, int > | signal_drag_action_ask ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::File >&, PlacesOpenFlags > | signal_open_location ()
Glib::SignalProxy< void, Menu*, const Glib::RefPtr< Gio::File >&, const Glib::RefPtr< Gio::Volume >& > | signal_populate_popup ()
Glib::SignalProxy< void > | signal_show_connect_to_server ()
Glib::SignalProxy< void, const Glib::ustring&, const Glib::ustring& > | signal_show_error_message ()
Glib::SignalProxy< void > | signal_show_enter_location ()
Glib::SignalProxy< void > | signal_show_other_locations ()
Glib::SignalProxy< void, PlacesOpenFlags > | signal_show_other_locations_with_flags ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::MountOperation >& > | signal_mount ()
Glib::SignalProxy< void, const Glib::RefPtr< Gio::MountOperation >& > | signal_unmount ()
Glib::PropertyProxy< bool > | property_local_only ()
| Whether the sidebar only includes local files. More...
Glib::PropertyProxy_ReadOnly< bool > | property_local_only () const
| Whether the sidebar only includes local files. More...
Glib::PropertyProxy< Glib::RefPtr< Gio::File > > | property_location ()
| The location to highlight in the sidebar. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gio::File > > | property_location () const
| The location to highlight in the sidebar. More...
Glib::PropertyProxy< PlacesOpenFlags > | property_open_flags ()
| Modes in which the calling application can open locations selected in the sidebar. More...
Glib::PropertyProxy_ReadOnly< PlacesOpenFlags > | property_open_flags () const
| Modes in which the calling application can open locations selected in the sidebar. More...
Glib::PropertyProxy< bool > | property_show_connect_to_server ()
| Whether the sidebar includes a builtin shortcut to a 'Connect to server' dialog. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_connect_to_server () const
| Whether the sidebar includes a builtin shortcut to a 'Connect to server' dialog. More...
Glib::PropertyProxy< bool > | property_show_desktop ()
| Whether the sidebar includes a builtin shortcut to the Desktop folder. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_desktop () const
| Whether the sidebar includes a builtin shortcut to the Desktop folder. More...
Glib::PropertyProxy< bool > | property_show_enter_location ()
| Whether the sidebar includes a builtin shortcut to manually enter a location. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_enter_location () const
| Whether the sidebar includes a builtin shortcut to manually enter a location. More...
Glib::PropertyProxy< bool > | property_show_recent ()
| Whether the sidebar includes a builtin shortcut for recent files. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_recent () const
| Whether the sidebar includes a builtin shortcut for recent files. More...
Glib::PropertyProxy< bool > | property_show_trash ()
| Whether the sidebar includes a builtin shortcut to the Trash location. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_trash () const
| Whether the sidebar includes a builtin shortcut to the Trash location. More...
Glib::PropertyProxy< bool > | property_show_other_locations ()
| Whether the sidebar includes an item to show external locations. More...
Glib::PropertyProxy_ReadOnly< bool > | property_show_other_locations () const
| Whether the sidebar includes an item to show external locations. More...
Glib::PropertyProxy< bool > | property_populate_all ()
| If :populate-all is `true`, the Gtk::PlacesSidebar::signal_populate_popup() signal is also emitted for popovers. More...
Glib::PropertyProxy_ReadOnly< bool > | property_populate_all () const
| If :populate-all is `true`, the Gtk::PlacesSidebar::signal_populate_popup() signal is also emitted for popovers. More...
Public Member Functions inherited from Gtk::ScrolledWindow
| ScrolledWindow (ScrolledWindow&& src) noexcept
ScrolledWindow& | operator= (ScrolledWindow&& src) noexcept
| ScrolledWindow (const ScrolledWindow&)=delete
ScrolledWindow& | operator= (const ScrolledWindow&)=delete
| ~ScrolledWindow () noexcept override
GtkScrolledWindow* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkScrolledWindow* | gobj () const
| Provides access to the underlying C GObject. More...
| ScrolledWindow ()
| ScrolledWindow (const Glib::RefPtr< Adjustment >& hadjustment, const Glib::RefPtr< Adjustment >& vadjustment)
void | set_hadjustment (const Glib::RefPtr< Adjustment >& hadjustment)
| Sets the Gtk::Adjustment for the horizontal scrollbar. More...
void | set_vadjustment (const Glib::RefPtr< Adjustment >& vadjustment)
| Sets the Gtk::Adjustment for the vertical scrollbar. More...
Glib::RefPtr< Adjustment > | get_hadjustment ()
| Returns the horizontal scrollbar’s adjustment, used to connect the horizontal scrollbar to the child widget’s horizontal scroll functionality. More...
Glib::RefPtr< const Adjustment > | get_hadjustment () const
| Returns the horizontal scrollbar’s adjustment, used to connect the horizontal scrollbar to the child widget’s horizontal scroll functionality. More...
Glib::RefPtr< Adjustment > | get_vadjustment ()
| Returns the vertical scrollbar’s adjustment, used to connect the vertical scrollbar to the child widget’s vertical scroll functionality. More...
Glib::RefPtr< const Adjustment > | get_vadjustment () const
| Returns the vertical scrollbar’s adjustment, used to connect the vertical scrollbar to the child widget’s vertical scroll functionality. More...
void | set_policy (PolicyType hscrollbar_policy, PolicyType vscrollbar_policy)
| Sets the scrollbar policy for the horizontal and vertical scrollbars. More...
void | get_policy (PolicyType& hscrollbar_policy, PolicyType& vscrollbar_policy) const
| Retrieves the current policy values for the horizontal and vertical scrollbars. More...
void | set_placement (CornerType window_placement)
| Sets the placement of the contents with respect to the scrollbars for the scrolled window. More...
void | unset_placement ()
| Unsets the placement of the contents with respect to the scrollbars for the scrolled window. More...
CornerType | get_placement () const
| Gets the placement of the contents with respect to the scrollbars for the scrolled window. More...
void | set_shadow_type (ShadowType type)
| Changes the type of shadow drawn around the contents of scrolled_window. More...
ShadowType | get_shadow_type () const
| Gets the shadow type of the scrolled window. More...
void | add (Gtk::Widget& widget) override
| Puts the child inside a Gtk::Viewport if it doesn't have native scrolling capability. More...
void | remove_with_viewport ()
| Removes the contained widget, possibly also a Gtk::Viewport. More...
Scrollbar* | get_vscrollbar ()
| Returns the vertical scrollbar of scrolled_window. More...
const Scrollbar* | get_vscrollbar () const
| Returns the vertical scrollbar of scrolled_window. More...
Scrollbar* | get_hscrollbar ()
| Returns the horizontal scrollbar of scrolled_window. More...
const Scrollbar* | get_hscrollbar () const
| Returns the horizontal scrollbar of scrolled_window. More...
int | get_min_content_width () const
| Gets the minimum content width of scrolled_window, or -1 if not set. More...
void | set_min_content_width (int width)
| Sets the minimum width that scrolled_window should keep visible. More...
int | get_min_content_height () const
| Gets the minimal content height of scrolled_window, or -1 if not set. More...
void | set_min_content_height (int height)
| Sets the minimum height that scrolled_window should keep visible. More...
void | set_kinetic_scrolling (bool kinetic_scrolling=true)
| Turns kinetic scrolling on or off. More...
bool | get_kinetic_scrolling () const
| Returns the specified kinetic scrolling behavior. More...
void | set_capture_button_press (bool capture_button_press)
| Changes the behaviour of scrolled_window with regard to the initial event that possibly starts kinetic scrolling. More...
bool | get_capture_button_press () const
| Return whether button presses are captured during kinetic scrolling. More...
void | set_overlay_scrolling (bool overlay_scrolling=true)
| Enables or disables overlay scrolling for this scrolled window. More...
bool | get_overlay_scrolling () const
| Returns whether overlay scrolling is enabled for this scrolled window. More...
void | set_max_content_width (int width)
| Sets the maximum width that scrolled_window should keep visible. More...
int | get_max_content_width () const
| Returns the maximum content width set. More...
void | set_max_content_height (int height)
| Sets the maximum height that scrolled_window should keep visible. More...
int | get_max_content_height () const
| Returns the maximum content height set. More...
void | set_propagate_natural_width (bool propagate=true)
| Sets whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width. More...
bool | get_propagate_natural_width () const
| Reports whether the natural width of the child will be calculated and propagated through the scrolled window’s requested natural width. More...
void | set_propagate_natural_height (bool propagate=true)
| Sets whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height. More...
bool | get_propagate_natural_height () const
| Reports whether the natural height of the child will be calculated and propagated through the scrolled window’s requested natural height. More...
Glib::SignalProxy< void, Gtk::PositionType > | signal_edge_overshot ()
Glib::SignalProxy< void, Gtk::PositionType > | signal_edge_reached ()
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_hadjustment ()
| The GtkAdjustment for the horizontal position. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_hadjustment () const
| The GtkAdjustment for the horizontal position. More...
Glib::PropertyProxy< Glib::RefPtr< Adjustment > > | property_vadjustment ()
| The GtkAdjustment for the vertical position. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Adjustment > > | property_vadjustment () const
| The GtkAdjustment for the vertical position. More...
Glib::PropertyProxy< PolicyType > | property_hscrollbar_policy ()
| When the horizontal scrollbar is displayed. More...
Glib::PropertyProxy_ReadOnly< PolicyType > | property_hscrollbar_policy () const
| When the horizontal scrollbar is displayed. More...
Glib::PropertyProxy< PolicyType > | property_vscrollbar_policy ()
| When the vertical scrollbar is displayed. More...
Glib::PropertyProxy_ReadOnly< PolicyType > | property_vscrollbar_policy () const
| When the vertical scrollbar is displayed. More...
Glib::PropertyProxy< CornerType > | property_window_placement ()
| Where the contents are located with respect to the scrollbars. More...
Glib::PropertyProxy_ReadOnly< CornerType > | property_window_placement () const
| Where the contents are located with respect to the scrollbars. More...
Glib::PropertyProxy< bool > | property_window_placement_set ()
| Whether "window-placement" should be used to determine the location of the contents with respect to the scrollbars. More...
Glib::PropertyProxy_ReadOnly< bool > | property_window_placement_set () const
| Whether "window-placement" should be used to determine the location of the contents with respect to the scrollbars. More...
Glib::PropertyProxy< ShadowType > | property_shadow_type ()
| Style of bevel around the contents. More...
Glib::PropertyProxy_ReadOnly< ShadowType > | property_shadow_type () const
| Style of bevel around the contents. More...
Glib::PropertyProxy< int > | property_min_content_width ()
| The minimum content width of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy_ReadOnly< int > | property_min_content_width () const
| The minimum content width of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy< int > | property_min_content_height ()
| The minimum content height of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy_ReadOnly< int > | property_min_content_height () const
| The minimum content height of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy< bool > | property_kinetic_scrolling ()
| Whether kinetic scrolling is enabled or not. More...
Glib::PropertyProxy_ReadOnly< bool > | property_kinetic_scrolling () const
| Whether kinetic scrolling is enabled or not. More...
Glib::PropertyProxy< bool > | property_overlay_scrolling ()
| Whether overlay scrolling is enabled or not. More...
Glib::PropertyProxy_ReadOnly< bool > | property_overlay_scrolling () const
| Whether overlay scrolling is enabled or not. More...
Glib::PropertyProxy< int > | property_max_content_width ()
| The maximum content width of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy_ReadOnly< int > | property_max_content_width () const
| The maximum content width of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy< int > | property_max_content_height ()
| The maximum content height of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy_ReadOnly< int > | property_max_content_height () const
| The maximum content height of scrolled_window, or -1 if not set. More...
Glib::PropertyProxy< bool > | property_propagate_natural_width ()
| Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width. More...
Glib::PropertyProxy_ReadOnly< bool > | property_propagate_natural_width () const
| Whether the natural width of the child should be calculated and propagated through the scrolled window’s requested natural width. More...
Glib::PropertyProxy< bool > | property_propagate_natural_height ()
| Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height. More...
Glib::PropertyProxy_ReadOnly< bool > | property_propagate_natural_height () const
| Whether the natural height of the child should be calculated and propagated through the scrolled window’s requested natural height. More...
Public Member Functions inherited from Gtk::Bin
| Bin (Bin&& src) noexcept
Bin& | operator= (Bin&& src) noexcept
| Bin (const Bin&)=delete
Bin& | operator= (const Bin&)=delete
| ~Bin () noexcept override
GtkBin* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBin* | gobj () const
| Provides access to the underlying C GObject. More...
Gtk::Widget* | get_child ()
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
const Gtk::Widget* | get_child () const
| Gets the child of the Gtk::Bin, or `nullptr` if the bin contains no child widget. More...
void | remove ()
| Remove the contained widget. More...
void | add_label (const Glib::ustring& label, bool mnemonic=false, double x_align=0.5, double y_align=0.5)
| Add a Label object. More...
void | add_label (const Glib::ustring& label, bool mnemonic, Align x_align, Align y_align=ALIGN_CENTER)
| Add a Label object. More...
void | add_pixlabel (const std::string& pixfile, const Glib::ustring& label, double x_align=0.5, double y_align=0.5)
| Add Image and Label objects. More...
void | add_pixlabel (const std::string& pixfile, const Glib::ustring& label, Align x_align, Align y_align=ALIGN_CENTER)
| Add Image and Label objects. More...
Public Member Functions inherited from Gtk::Container
| Container (Container&& src) noexcept
Container& | operator= (Container&& src) noexcept
| Container (const Container&)=delete
Container& | operator= (const Container&)=delete
| ~Container () noexcept override
GtkContainer* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkContainer* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_border_width (guint border_width)
| Sets the border width of the container. More...
guint | get_border_width () const
| Retrieves the border width of the container. More...
void | remove (Widget& widget)
| Removes widget from the container. More...
void | set_resize_mode (ResizeMode resize_mode)
| Sets the resize mode for the container. More...
ResizeMode | get_resize_mode () const
| Returns the resize mode for the container. More...
void | check_resize ()
| Request that contained widgets check their size. More...
void | foreach (const ForeachSlot& slot)
| Operate on contained items. More...
void | forall (const ForeachSlot& slot)
| Operate on contained items, including internal children. More...
std::vector< Widget* > | get_children ()
| Returns the container’s non-internal children. More...
std::vector< const Widget* > | get_children () const
| Returns the container’s non-internal children. More...
void | propagate_draw (Widget& child, const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| When a container receives a call to the draw function, it must send synthetic Gtk::Widget::signal_draw() calls to all children that don’t have their own Gdk::Windows. More...
void | set_focus_chain (const std::vector< Widget* >& focusable_widgets)
| Sets a focus chain, overriding the one computed automatically by GTK+. More...
bool | has_focus_chain () const
std::vector< Widget* > | get_focus_chain ()
std::vector< const Widget* > | get_focus_chain () const
void | unset_focus_chain ()
| Removes a focus chain explicitly set with set_focus_chain(). More...
void | set_reallocate_redraws (bool needs_redraws=true)
| Sets the reallocate_redraws flag of the container to the given value. More...
void | set_focus_child (Widget& widget)
| Sets the focus on a child. More...
Widget* | get_focus_child ()
| Returns the current focus child widget inside container. More...
const Widget* | get_focus_child () const
| Returns the current focus child widget inside container. More...
void | set_focus_vadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_vadjustment ()
| Retrieves the vertical focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_vadjustment () const
| Retrieves the vertical focus adjustment for the container. More...
void | set_focus_hadjustment (const Glib::RefPtr< Adjustment >& adjustment)
| Hooks up an adjustment to focus handling in a container, so when a child of the container is focused, the adjustment is scrolled to show that widget. More...
Glib::RefPtr< Adjustment > | get_focus_hadjustment ()
| Retrieves the horizontal focus adjustment for the container. More...
Glib::RefPtr< const Adjustment > | get_focus_hadjustment () const
| Retrieves the horizontal focus adjustment for the container. More...
void | resize_children ()
GType | child_type () const
| Returns the type of the children supported by the container. More...
WidgetPath | get_path_for_child (const Widget& child) const
| Returns a newly created widget path representing all the widget hierarchy from the toplevel down to and including child. More...
Glib::SignalProxy< void, Widget* > | signal_add ()
Glib::SignalProxy< void, Widget* > | signal_remove ()
Glib::SignalProxy< void > | signal_check_resize ()
Glib::SignalProxy< void, Widget* > | signal_set_focus_child ()
void | show_all_children (bool recursive=true)
Public Member Functions inherited from Gtk::Widget
| Widget (Widget&& src) noexcept
Widget& | operator= (Widget&& src) noexcept
| Widget (const Widget&)=delete
Widget& | operator= (const Widget&)=delete
| ~Widget () noexcept override
| Destroys the widget. More...
GtkWidget* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkWidget* | gobj () const
| Provides access to the underlying C GObject. More...
void | show ()
| Flags a widget to be displayed. More...
void | show_now ()
| Shows a widget. More...
void | hide ()
| Reverses the effects of show(), causing the widget to be hidden (invisible to the user). More...
void | show_all ()
| Recursively shows a widget, and any child widgets (if the widget is a container). More...
void | queue_draw ()
| Equivalent to calling queue_draw_area() for the entire area of a widget. More...
void | queue_draw_area (int x, int y, int width, int height)
| Convenience function that calls queue_draw_region() on the region created from the given coordinates. More...
void | queue_draw_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Invalidates the area of widget defined by region by calling gdk_window_invalidate_region() on the widget’s window and all its child windows. More...
void | queue_resize ()
| This function is only for use in widget implementations. More...
void | queue_allocate ()
| This function is only for use in widget implementations. More...
void | size_allocate (const Allocation& allocation)
| This function is only used by Gtk::Container subclasses, to assign a size and position to their child widgets. More...
void | size_allocate (const Allocation& allocation, int baseline)
| This function is only used by Gtk::Container subclasses, to assign a size, position and (optionally) baseline to their child widgets. More...
SizeRequestMode | get_request_mode () const
| Gets whether the widget prefers a height-for-width layout or a width-for-height layout. More...
void | get_preferred_width (int& minimum_width, int& natural_width) const
| Retrieves a widget’s initial minimum and natural width. More...
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height) const
| Retrieves a widget’s minimum and natural height if it would be given the specified width. More...
void | get_preferred_height_for_width (int width, int& minimum_height, int& natural_height, int& minimum_baseline, int& natural_baseline) const
| Retrieves a widget’s minimum and natural height and the corresponding baselines if it would be given the specified width, or the default height if width is -1. More...
void | get_preferred_height (int& minimum_height, int& natural_height) const
| Retrieves a widget’s initial minimum and natural height. More...
void | get_preferred_width_for_height (int height, int& minimum_width, int& natural_width) const
| Retrieves a widget’s minimum and natural width if it would be given the specified height. More...
void | get_preferred_size (Requisition& minimum_size, Requisition& natural_size) const
| Retrieves the minimum and natural size of a widget, taking into account the widget’s preference for height-for-width management. More...
void | add_accelerator (const Glib::ustring& accel_signal, const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods, AccelFlags accel_flags)
| Installs an accelerator for this widget in accel_group that causes accel_signal to be emitted if the accelerator is activated. More...
bool | remove_accelerator (const Glib::RefPtr< AccelGroup >& accel_group, guint accel_key, Gdk::ModifierType accel_mods)
| Removes an accelerator from widget, previously installed with add_accelerator(). More...
void | set_accel_path (const Glib::ustring& accel_path, const Glib::RefPtr< AccelGroup >& accel_group)
| Given an accelerator group, accel_group, and an accelerator path, accel_path, sets up an accelerator in accel_group so whenever the key binding that is defined for accel_path is pressed, widget will be activated. More...
bool | mnemonic_activate (bool group_cycling)
| Emits the Gtk::Widget::signal_mnemonic_activate() signal. More...
bool | event (GdkEvent* gdk_event)
| Rarely-used function. More...
int | send_expose (GdkEvent* gdk_event)
| Very rarely-used function. More...
bool | send_focus_change (GdkEvent* gdk_event)
| Sends the focus change gdk_event to widget. More...
bool | activate ()
| For widgets that can be “activated” (buttons, menu items, etc.) this function activates them. More...
void | reparent (Widget& new_parent)
| Moves a widget from one Gtk::Container to another, handling reference count issues to avoid destroying the widget. More...
bool | intersect (const Gdk::Rectangle& area) const
bool | intersect (const Gdk::Rectangle& area, Gdk::Rectangle& intersection) const
| Computes the intersection of a widget’s area and area, storing the intersection in intersection, and returns `true` if there was an intersection. More...
::Cairo::RefPtr< ::Cairo::Region > | region_intersect (const ::Cairo::RefPtr< ::Cairo::Region >& region) const
| Computes the intersection of a widget’s area and region, returning the intersection. More...
void | freeze_child_notify ()
| Stops emission of Gtk::Widget::signal_child_notify() signals on widget. More...
void | child_notify (const Glib::ustring& child_property)
| Emits a Gtk::Widget::signal_child_notify() signal for the [child property][child-properties] child_property on widget. More...
void | thaw_child_notify ()
| Reverts the effect of a previous call to freeze_child_notify(). More...
void | set_can_focus (bool can_focus=true)
| Specifies whether widget can own the input focus. More...
bool | get_can_focus () const
| Determines whether widget can own the input focus. More...
bool | has_focus () const
| Determines if the widget has the global input focus. More...
bool | is_focus () const
| Determines if the widget is the focus widget within its toplevel. More...
bool | has_visible_focus () const
| Determines if the widget should show a visible indication that it has the global input focus. More...
void | grab_focus ()
| Causes widget to have the keyboard focus for the Gtk::Window it's inside. More...
void | set_focus_on_click (bool focus_on_click=true)
| Sets whether the widget should grab focus when it is clicked with the mouse. More...
bool | get_focus_on_click () const
| Returns whether the widget should grab focus when it is clicked with the mouse. More...
void | set_can_default (bool can_default=true)
| Specifies whether widget can be a default widget. More...
bool | get_can_default () const
| Determines whether widget can be a default widget. More...
bool | has_default () const
| Determines whether widget is the current default widget within its toplevel. More...
void | grab_default ()
| Causes widget to become the default widget. More...
void | set_receives_default (bool receives_default=true)
| Specifies whether widget will be treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | get_receives_default () const
| Determines whether widget is always treated as the default widget within its toplevel when it has the focus, even if another widget is the default. More...
bool | has_grab () const
| Determines whether the widget is currently grabbing events, so it is the only widget receiving input events (keyboard and mouse). More...
bool | device_is_shadowed (const Glib::RefPtr< const Gdk::Device >& device)
| Returns `true` if device has been shadowed by a GTK+ device grab on another widget, so it would stop sending events to widget. More...
void | add_modal_grab ()
| Block events to everything else than this widget and its children. More...
void | remove_modal_grab ()
| Remove the modal grab of the widget in case it was previously grabbed. More...
void | set_name (const Glib::ustring& name)
| Widgets can be named, which allows you to refer to them from a CSS file. More...
void | unset_name ()
Glib::ustring | get_name () const
| Retrieves the name of a widget. More...
void | set_state (StateType state)
| This function is for use in widget implementations. More...
StateType | get_state () const
| Returns the widget’s state. More...
void | set_state_flags (StateFlags flags, bool clear=true)
| This function is for use in widget implementations. More...
void | unset_state_flags (StateFlags flags)
| This function is for use in widget implementations. More...
StateFlags | get_state_flags () const
| Returns the widget state as a flag set. More...
void | set_sensitive (bool sensitive=true)
| Sets the sensitivity of a widget. More...
bool | get_sensitive () const
| Returns the widget’s sensitivity (in the sense of returning the value that has been set using set_sensitive()). More...
bool | is_sensitive () const
| Returns the widget’s effective sensitivity, which means it is sensitive itself and also its parent widget is sensitive. More...
void | set_visible (bool visible=true)
| Sets the visibility state of widget. More...
bool | get_visible () const
| Determines whether the widget is visible. More...
bool | is_visible () const
| Determines whether the widget and all its parents are marked as visible. More...
bool | get_has_window () const
| Determines whether widget has a Gdk::Window of its own. More...
bool | get_is_toplevel () const
| Determines whether widget is a toplevel widget. More...
bool | get_is_drawable () const
| Determines whether widget can be drawn to. More...
bool | get_realized () const
| Determines whether widget is realized. More...
bool | get_mapped () const
| Whether the widget is mapped. More...
void | set_app_paintable (bool app_paintable=true)
| Sets whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler. More...
bool | get_app_paintable () const
| Determines whether the application intends to draw on the widget in an Gtk::Widget::signal_draw() handler. More...
void | set_double_buffered (bool double_buffered=true)
| Widgets are double buffered by default; you can use this function to turn off the buffering. More...
bool | get_double_buffered () const
| Determines whether the widget is double buffered. More...
void | set_redraw_on_allocate (bool redraw_on_allocate=true)
| Sets whether the entire widget is queued for drawing when its size allocation changes. More...
void | set_child_visible (bool visible=true)
| Sets whether widget should be mapped along with its when its parent is mapped and widget has been shown with show(). More...
bool | get_child_visible () const
| Gets the value set with set_child_visible(). More...
Glib::RefPtr< Gdk::Window > | get_window ()
| Returns the widget’s window if it is realized, `nullptr` otherwise. More...
Glib::RefPtr< const Gdk::Window > | get_window () const
| Returns the widget’s window if it is realized, `nullptr` otherwise. More...
void | register_window (const Glib::RefPtr< Gdk::Window >& window)
| Registers a Gdk::Window with the widget and sets it up so that the widget receives events for it. More...
void | unregister_window (const Glib::RefPtr< Gdk::Window >& window)
| Unregisters a Gdk::Window from the widget that was previously set up with register_window(). More...
int | get_allocated_width () const
| Returns the width that has currently been allocated to widget. More...
int | get_allocated_height () const
| Returns the height that has currently been allocated to widget. More...
int | get_allocated_baseline () const
| Returns the baseline that has currently been allocated to widget. More...
void | get_allocated_size (Allocation& allocation, int& baseline) const
| Retrieves the widget’s allocated size. More...
Allocation | get_allocation () const
| Retrieves the widget's location. More...
void | set_allocation (const Allocation& allocation)
| Sets the widget’s allocation. More...
void | set_clip (const Allocation& clip)
| Sets the widget’s clip. More...
Allocation | get_clip () const
| Retrieves the widget’s clip area. More...
Container* | get_parent ()
| Returns the parent container of widget. More...
const Container* | get_parent () const
| Returns the parent container of widget. More...
Glib::RefPtr< Gdk::Window > | get_parent_window ()
| Gets widget’s parent window, or `nullptr` if it does not have one. More...
Glib::RefPtr< const Gdk::Window > | get_parent_window () const
| Gets widget’s parent window, or `nullptr` if it does not have one. More...
void | set_parent_window (const Glib::RefPtr< const Gdk::Window >& parent_window)
| Sets a non default parent window for widget. More...
bool | child_focus (DirectionType direction)
| This function is used by custom widget implementations; if you're writing an app, you’d use grab_focus() to move the focus to a particular widget, and Gtk::Container::set_focus_chain() to change the focus tab order. More...
bool | keynav_failed (DirectionType direction)
| This function should be called whenever keyboard navigation within a single widget hits a boundary. More...
void | error_bell ()
| Notifies the user about an input-related error on this widget. More...
void | set_size_request (int width=-1, int height=-1)
| Sets the minimum size of a widget; that is, the widget’s size request will be at least width by height. More...
void | get_size_request (int& width, int& height) const
| Gets the size request that was explicitly set for the widget using set_size_request(). More...
void | set_events (Gdk::EventMask events)
| Sets the event mask (see Gdk::EventMask) for a widget. More...
void | add_events (Gdk::EventMask events)
| Adds the events in the bitfield events to the event mask for widget. More...
void | set_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Sets the device event mask (see Gdk::EventMask) for a widget. More...
void | add_device_events (const Glib::RefPtr< const Gdk::Device >& device, Gdk::EventMask events)
| Adds the device events in the bitfield events to the event mask for widget. More...
void | set_opacity (double opacity)
| Request the widget to be rendered partially transparent, with opacity 0 being fully transparent and 1 fully opaque. More...
double | get_opacity () const
| Fetches the requested opacity for this widget. More...
void | set_device_enabled (const Glib::RefPtr< Gdk::Device >& device, bool enabled=true)
| Enables or disables a Gdk::Device to interact with widget and all its children. More...
bool | get_device_enabled (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns whether device can interact with widget and its children. More...
Container* | get_toplevel ()
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
const Container* | get_toplevel () const
| This function returns the topmost widget in the container hierarchy widget is a part of. More...
Widget* | get_ancestor (GType widget_type)
| Gets the first ancestor of widget with type widget_type. More...
const Widget* | get_ancestor (GType widget_type) const
| Gets the first ancestor of widget with type widget_type. More...
Glib::RefPtr< Gdk::Visual > | get_visual ()
| Gets the visual that will be used to render widget. More...
Glib::RefPtr< Gdk::Screen > | get_screen ()
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Screen > | get_screen () const
| Get the Gdk::Screen from the toplevel window associated with this widget. More...
bool | has_screen () const
| Checks whether there is a Gdk::Screen is associated with this widget. More...
int | get_scale_factor () const
| Retrieves the internal scale factor that maps from window coordinates to the actual device pixels. More...
Glib::RefPtr< Gdk::Display > | get_display ()
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< const Gdk::Display > | get_display () const
| Get the Gdk::Display for the toplevel window associated with this widget. More...
Glib::RefPtr< Gdk::Window > | get_root_window ()
| Get the root window where this widget is located. More...
Glib::RefPtr< const Gdk::Window > | get_root_window () const
| Get the root window where this widget is located. More...
Glib::RefPtr< Settings > | get_settings ()
| Gets the settings object holding the settings used for this widget. More...
Glib::RefPtr< Clipboard > | get_clipboard (const Glib::ustring& selection)
| Returns the clipboard object for the given selection to be used with widget. More...
Glib::RefPtr< const Clipboard > | get_clipboard (const Glib::ustring& selection) const
| Returns the clipboard object for the given selection to be used with widget. More...
bool | get_hexpand () const
| Gets whether the widget would like any available extra horizontal space. More...
void | set_hexpand (bool expand=true)
| Sets whether the widget would like any available extra horizontal space. More...
bool | get_hexpand_set () const
| Gets whether set_hexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_hexpand_set (bool set=true)
| Sets whether the hexpand flag (see get_hexpand()) will be used. More...
bool | get_vexpand () const
| Gets whether the widget would like any available extra vertical space. More...
void | set_vexpand (bool expand=true)
| Sets whether the widget would like any available extra vertical space. More...
bool | get_vexpand_set () const
| Gets whether set_vexpand() has been used to explicitly set the expand flag on this widget. More...
void | set_vexpand_set (bool set=true)
| Sets whether the vexpand flag (see get_vexpand()) will be used. More...
void | queue_compute_expand ()
| Mark widget as needing to recompute its expand flags. More...
bool | compute_expand (Orientation orientation)
| Computes whether a container should give this widget extra space when possible. More...
bool | get_support_multidevice () const
| Returns `true` if widget is multiple pointer aware. More...
void | set_support_multidevice (bool support_multidevice=true)
| Enables or disables multiple pointer awareness. More...
Glib::RefPtr< Atk::Object > | get_accessible ()
| Returns the accessible object that describes the widget to an assistive technology. More...
Glib::RefPtr< const Atk::Object > | get_accessible () const
| Returns the accessible object that describes the widget to an assistive technology. More...
Align | get_halign () const
| Gets the value of the Gtk::Widget::property_halign() property. More...
void | set_halign (Align align)
| Sets the horizontal alignment of widget. More...
Align | get_valign () const
| Gets the value of the Gtk::Widget::property_valign() property. More...
Align | get_valign_with_baseline () const
| Gets the value of the Gtk::Widget::property_valign() property, including Gtk::ALIGN_BASELINE. More...
void | set_valign (Align align)
| Sets the vertical alignment of widget. More...
int | get_margin_left () const
| Gets the value of the Gtk::Widget::property_margin_left() property. More...
void | set_margin_left (int margin)
| Sets the left margin of widget. More...
int | get_margin_right () const
| Gets the value of the Gtk::Widget::property_margin_right() property. More...
void | set_margin_right (int margin)
| Sets the right margin of widget. More...
int | get_margin_start () const
| Gets the value of the Gtk::Widget::property_margin_start() property. More...
void | set_margin_start (int margin)
| Sets the start margin of widget. More...
int | get_margin_end () const
| Gets the value of the Gtk::Widget::property_margin_end() property. More...
void | set_margin_end (int margin)
| Sets the end margin of widget. More...
int | get_margin_top () const
| Gets the value of the Gtk::Widget::property_margin_top() property. More...
void | set_margin_top (int margin)
| Sets the top margin of widget. More...
int | get_margin_bottom () const
| Gets the value of the Gtk::Widget::property_margin_bottom() property. More...
void | set_margin_bottom (int margin)
| Sets the bottom margin of widget. More...
Gdk::EventMask | get_events () const
| Returns the event mask (see Gdk::EventMask) for the widget. More...
Gdk::EventMask | get_device_events (const Glib::RefPtr< const Gdk::Device >& device) const
| Returns the events mask for the widget corresponding to an specific device. More...
void | get_pointer (int& x, int& y) const
| Obtains the location of the mouse pointer in widget coordinates. More...
bool | is_ancestor (Widget& ancestor) const
| Determines whether widget is somewhere inside ancestor, possibly with intermediate containers. More...
bool | translate_coordinates (Widget& dest_widget, int src_x, int src_y, int& dest_x, int& dest_y)
| Translate coordinates relative to src_widget’s allocation to coordinates relative to dest_widget’s allocations. More...
void | override_color (const Gdk::RGBA& color, StateFlags state=STATE_FLAG_NORMAL)
| Sets the color to use for a widget. More...
void | unset_color (StateFlags state=STATE_FLAG_NORMAL)
| Undoes the effect of previous calls to override_color(). More...
void | override_background_color (const Gdk::RGBA& color, StateFlags state=STATE_FLAG_NORMAL)
| Sets the background color to use for a widget. More...
void | unset_background_color (StateFlags state=STATE_FLAG_NORMAL)
| Undoes the effect of previous calls to override_background_color(). More...
void | override_font (const Pango::FontDescription& font_desc)
| Sets the font to use for a widget. More...
void | unset_font ()
| Undoes the effect of previous calls to override_font(). More...
void | override_symbolic_color (const Glib::ustring& name, const Gdk::RGBA& color)
| Sets a symbolic color for a widget. More...
void | unset_symbolic_color (const Glib::ustring& name)
| Undoes the effect of previous calls to override_symbolic_color(). More...
void | override_cursor (const Gdk::RGBA& cursor, const Gdk::RGBA& secondary_cursor)
| Sets the cursor color to use in a widget, overriding the cursor-color and secondary-cursor-color style properties. More...
void | unset_cursor ()
| Undoes the effect of previous calls to override_cursor(). More...
void | reset_style ()
| Updates the style context of widget and all descendants by updating its widget path. More...
template<class PropertyType >
void | get_style_property (const Glib::ustring& the_property_name, PropertyType& value) const
| Gets the value of a style property of widget. More...
Glib::RefPtr< Pango::Context > | create_pango_context ()
| Creates a new Pango::Context with the appropriate font map, font options, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Pango::Context > | get_pango_context ()
| Gets a Pango::Context with the appropriate font map, font description, and base direction for this widget. More...
void | set_font_options (const ::Cairo::FontOptions& options)
| Sets the #cairo_font_options_t used for Pango rendering in this widget. More...
void | unset_font_options ()
| Undoes the effect of previous calls to set_font_options(). More...
::Cairo::FontOptions | get_font_options () const
| Returns the #cairo_font_options_t used for Pango rendering. More...
Glib::RefPtr< Pango::Layout > | create_pango_layout (const Glib::ustring& text)
| Creates a new Pango::Layout with the appropriate font map, font description, and base direction for drawing text for this widget. More...
Glib::RefPtr< Gdk::Pixbuf > | render_icon_pixbuf (const StockID& stock_id, IconSize size)
| A convenience function that uses the theme engine and style settings for widget to look up stock_id and render it to a pixbuf. More...
void | set_composite_name (const Glib::ustring& name)
| Sets a widgets composite name. More...
void | unset_composite_name ()
Glib::ustring | get_composite_name () const
| Obtains the composite name of a widget. More...
void | set_direction (TextDirection dir)
| Sets the reading direction on a particular widget. More...
TextDirection | get_direction () const
| Gets the reading direction for a particular widget. More...
void | shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets a shape for this widget’s GDK window. More...
void | input_shape_combine_region (const ::Cairo::RefPtr< const ::Cairo::Region >& region)
| Sets an input shape for this widget’s GDK window. More...
WidgetPath | get_path () const
| Returns the Gtk::WidgetPath representing widget, if the widget is not connected to a toplevel widget, a partial path will be created. More...
std::vector< Widget* > | list_mnemonic_labels ()
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
std::vector< const Widget* > | list_mnemonic_labels () const
| Returns a newly allocated list of the widgets, normally labels, for which this widget is the target of a mnemonic (see for example, Gtk::Label::set_mnemonic_widget()). More...
void | add_mnemonic_label (Widget& label)
| Adds a widget to the list of mnemonic labels for this widget. More...
void | remove_mnemonic_label (Widget& label)
| Removes a widget from the list of mnemonic labels for this widget. More...
void | drag_get_data (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::ustring& target, guint32 time)
void | drag_highlight ()
void | drag_unhighlight ()
void | drag_dest_set (DestDefaults flags=DestDefaults(0), Gdk::DragAction actions=Gdk::DragAction(0))
void | drag_dest_set (const std::vector< TargetEntry >& targets, DestDefaults flags=DEST_DEFAULT_ALL, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_dest_set_proxy (const Glib::RefPtr< Gdk::Window >& proxy_window, Gdk::DragProtocol protocol, bool use_coordinates)
| Sets this widget as a proxy for drops to another window. More...
void | drag_dest_unset ()
| Clears information about a drop destination set with gtk_drag_dest_set(). More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context, const Glib::RefPtr< TargetList >& target_list) const
| Looks for a match between context->targets and the dest_target_list, returning the first matching target, otherwise returning GDK_NONE. More...
Glib::ustring | drag_dest_find_target (const Glib::RefPtr< Gdk::DragContext >& context) const
Glib::RefPtr< TargetList > | drag_dest_get_target_list ()
| Returns the list of targets this widget can accept from drag-and-drop. More...
Glib::RefPtr< const TargetList > | drag_dest_get_target_list () const
| Returns the list of targets this widget can accept from drag-and-drop. More...
void | drag_dest_set_target_list (const Glib::RefPtr< TargetList >& target_list)
| Sets the target types that this widget can accept from drag-and-drop. More...
void | drag_dest_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_dest_add_image_targets ()
| Add the image targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_dest_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag destination. More...
void | drag_source_set (const std::vector< TargetEntry >& targets, Gdk::ModifierType start_button_mask=Gdk::MODIFIER_MASK, Gdk::DragAction actions=Gdk::ACTION_COPY)
void | drag_source_unset ()
| Undoes the effects of gtk_drag_source_set(). More...
void | drag_source_set_icon (const Glib::RefPtr< Gdk::Pixbuf >& pixbuf)
| Sets the icon that will be used for drags from a particular widget from a Gdk::Pixbuf. More...
void | drag_source_set_icon (const StockID& stock_id)
| Sets the icon that will be used for drags from a particular source to a stock icon. More...
void | drag_source_set_icon (const Glib::ustring& icon_name)
| Sets the icon that will be used for drags from a particular source to a themed icon. More...
void | drag_source_add_text_targets ()
| Add the text targets supported by Gtk::SelectionData to the target list of the drag source. More...
void | drag_source_add_uri_targets ()
| Add the URI targets supported by Gtk::SelectionData to the target list of the drag source. More...
void | drag_source_add_image_targets ()
| Add the writable image targets supported by Gtk::SelectionData to the target list of the drag source. More...
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent* gdk_event)
Glib::RefPtr< Gdk::DragContext > | drag_begin (const Glib::RefPtr< TargetList >& targets, Gdk::DragAction actions, int button, GdkEvent* gdk_event, int x, int y)
bool | drag_check_threshold (int start_x, int start_y, int current_x, int current_y)
void | drag_set_as_icon (const Glib::RefPtr< Gdk::DragContext >& context, int hot_x, int hot_y)
void | queue_resize_no_redraw ()
| This function works like queue_resize(), except that the widget is not invalidated. More...
Glib::RefPtr< Gdk::FrameClock > | get_frame_clock ()
| Obtains the frame clock for a widget. More...
Glib::RefPtr< const Gdk::FrameClock > | get_frame_clock () const
| Obtains the frame clock for a widget. More...
bool | get_no_show_all () const
| Returns the current value of the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget. More...
void | set_no_show_all (bool no_show_all=true)
| Sets the Gtk::Widget::property_no_show_all() property, which determines whether calls to show_all() will affect this widget. More...
void | set_parent (Widget& parent)
| This function is useful only when implementing subclasses of Gtk::Container. More...
void | unparent ()
| This function is only for use in widget implementations. More...
void | map ()
| This function is only for use in widget implementations. More...
void | unmap ()
| This function is only for use in widget implementations. More...
void | draw_insertion_cursor (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Gdk::Rectangle& location, bool is_primary, TextDirection direction, bool draw_arrow=true)
| Draws a text caret on cr at location. More...
void | set_tooltip_window (Window& custom_window)
| Replaces the default window used for displaying tooltips with custom_window. More...
Window* | get_tooltip_window ()
| Returns the Gtk::Window of the current tooltip. More...
void | trigger_tooltip_query ()
| Triggers a tooltip query on the display where the toplevel of widget is located. More...
void | set_tooltip_text (const Glib::ustring& text)
| Sets text as the contents of the tooltip. More...
Glib::ustring | get_tooltip_text () const
| Gets the contents of the tooltip for widget. More...
void | set_tooltip_markup (const Glib::ustring& markup)
| Sets markup as the contents of the tooltip, which is marked up with the Pango text markup language. More...
Glib::ustring | get_tooltip_markup () const
| Gets the contents of the tooltip for widget. More...
void | set_has_tooltip (bool has_tooltip=TRUE)
| Sets the has-tooltip property on widget to has_tooltip. More...
bool | get_has_tooltip () const
| Returns the current value of the has-tooltip property. More...
int | get_width () const
int | get_height () const
bool | is_composited () const
| Whether widget can rely on having its alpha channel drawn correctly. More...
bool | in_destruction () const
| Returns whether the widget is currently being destroyed. More...
Glib::RefPtr< StyleContext > | get_style_context ()
| Returns the style context associated to widget. More...
Glib::RefPtr< Gtk::StyleContext > | get_style_context () const
| Returns the style context associated to widget. More...
Gdk::ModifierType | get_modifier_mask (Gdk::ModifierIntent intent)
| Returns the modifier mask the widget’s windowing system backend uses for a particular purpose. More...
guint | add_tick_callback (const SlotTick& slot)
| Queues an animation frame update and adds a callback to be called before each frame. More...
void | remove_tick_callback (guint id)
| Removes a tick callback previously registered with add_tick_callback(). More...
void | insert_action_group (const Glib::ustring& name, const Glib::RefPtr< Gio::ActionGroup >& group)
| Inserts group into widget. More...
void | remove_action_group (const Glib::ustring& name)
| Removes a group from the widget. More...
Glib::RefPtr< Gio::ActionGroup > | get_action_group (const Glib::ustring& prefix)
| Retrieves the Gio::ActionGroup that was registered using prefix. More...
Glib::RefPtr< const Gio::ActionGroup > | get_action_group (const Glib::ustring& prefix) const
| Retrieves the Gio::ActionGroup that was registered using prefix. More...
std::vector< Glib::ustring > | list_action_prefixes () const
| Retrieves a `nullptr`-terminated array of strings containing the prefixes of Gio::ActionGroup's available to widget. More...
void | set_font_map (const Glib::RefPtr< Pango::FontMap >& font_map)
| Sets the font map to use for Pango rendering. More...
Glib::RefPtr< Pango::FontMap > | get_font_map ()
| Gets the font map that has been set with set_font_map(). More...
Glib::RefPtr< const Pango::FontMap > | get_font_map () const
| Gets the font map that has been set with set_font_map(). More...
Glib::SignalProxy< void > | signal_show ()
Glib::SignalProxy< void > | signal_hide ()
Glib::SignalProxy< void > | signal_map ()
| Emitted on mapping of a widget to the screen. More...
Glib::SignalProxy< void > | signal_unmap ()
Glib::SignalProxy< void > | signal_realize ()
| Emitted on realization of a widget. More...
Glib::SignalProxy< void > | signal_unrealize ()
Glib::SignalProxy< void, Allocation& > | signal_size_allocate ()
Glib::SignalProxy< void, Gtk::StateType > | signal_state_changed ()
Glib::SignalProxy< void, Gtk::StateFlags > | signal_state_flags_changed ()
Glib::SignalProxy< void, Widget* > | signal_parent_changed ()
| Informs objects that their parent changed. More...
Glib::SignalProxy< void, Widget* > | signal_hierarchy_changed ()
Glib::SignalProxy< void > | signal_style_updated ()
Glib::SignalProxy< void, TextDirection > | signal_direction_changed ()
Glib::SignalProxy< void, bool > | signal_grab_notify ()
Glib::SignalProxy< void, GParamSpec* > | signal_child_notify ()
Glib::SignalProxyDetailedAnyType< void, GParamSpec* > | signal_child_notify (const Glib::ustring& child_property_name)
Glib::SignalProxy< bool, bool > | signal_mnemonic_activate ()
Glib::SignalProxy< void > | signal_grab_focus ()
Glib::SignalProxy< bool, DirectionType > | signal_focus ()
Glib::SignalProxy< bool, GdkEvent* > | signal_event ()
Glib::SignalProxy< void, GdkEvent* > | signal_event_after ()
Glib::SignalProxy< bool, GdkEventButton* > | signal_button_press_event ()
| Event triggered by user pressing button. More...
Glib::SignalProxy< bool, GdkEventButton* > | signal_button_release_event ()
| Event triggered by user releasing button. More...
Glib::SignalProxy< bool, GdkEventScroll* > | signal_scroll_event ()
Glib::SignalProxy< bool, GdkEventMotion* > | signal_motion_notify_event ()
| Event triggered by user moving pointer. More...
Glib::SignalProxy< bool, GdkEventAny* > | signal_delete_event ()
Glib::SignalProxy< bool, const ::Cairo::RefPtr< ::Cairo::Context >& > | signal_draw ()
Glib::SignalProxy< bool, GdkEventKey* > | signal_key_press_event ()
| Event triggered by a key press will widget has focus. More...
Glib::SignalProxy< bool, GdkEventKey* > | signal_key_release_event ()
| Event triggered by a key release will widget has focus. More...
Glib::SignalProxy< bool, GdkEventCrossing* > | signal_enter_notify_event ()
| Event triggered by pointer entering widget area. More...
Glib::SignalProxy< bool, GdkEventCrossing* > | signal_leave_notify_event ()
| Event triggered by pointer leaving widget area. More...
Glib::SignalProxy< bool, GdkEventConfigure* > | signal_configure_event ()
| Event triggered by a window resizing. More...
Glib::SignalProxy< bool, GdkEventFocus* > | signal_focus_in_event ()
Glib::SignalProxy< bool, GdkEventFocus* > | signal_focus_out_event ()
Glib::SignalProxy< bool, GdkEventAny* > | signal_map_event ()
Glib::SignalProxy< bool, GdkEventAny* > | signal_unmap_event ()
Glib::SignalProxy< bool, GdkEventProperty* > | signal_property_notify_event ()
Glib::SignalProxy< bool, GdkEventSelection* > | signal_selection_clear_event ()
Glib::SignalProxy< bool, GdkEventSelection* > | signal_selection_request_event ()
Glib::SignalProxy< bool, GdkEventSelection* > | signal_selection_notify_event ()
Glib::SignalProxy< bool, GdkEventProximity* > | signal_proximity_in_event ()
Glib::SignalProxy< bool, GdkEventProximity* > | signal_proximity_out_event ()
Glib::SignalProxy< bool, GdkEventVisibility* > | signal_visibility_notify_event ()
Glib::SignalProxy< bool, GdkEventWindowState* > | signal_window_state_event ()
Glib::SignalProxy< void, SelectionData&, guint, guint > | signal_selection_get ()
Glib::SignalProxy< void, const SelectionData&, guint > | signal_selection_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >& > | signal_drag_begin ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >& > | signal_drag_end ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, SelectionData&, guint, guint > | signal_drag_data_get ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >& > | signal_drag_data_delete ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, DragResult > | signal_drag_failed ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, guint > | signal_drag_leave ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_motion ()
Glib::SignalProxy< bool, const Glib::RefPtr< Gdk::DragContext >&, int, int, guint > | signal_drag_drop ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::DragContext >&, int, int, const SelectionData&, guint, guint > | signal_drag_data_received ()
Glib::SignalProxy< void, const Glib::RefPtr< Gdk::Screen >& > | signal_screen_changed ()
Glib::SignalProxy< void > | signal_composited_changed ()
Glib::SignalProxy< bool > | signal_popup_menu ()
Glib::SignalProxy< bool, int, int, bool, const Glib::RefPtr< Tooltip >& > | signal_query_tooltip ()
Glib::SignalProxy< bool, GdkEventGrabBroken* > | signal_grab_broken_event ()
Glib::SignalProxy< bool, GdkEventExpose* > | signal_damage_event ()
Glib::SignalProxy< bool, GdkEventTouch* > | signal_touch_event ()
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the widget. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the widget. More...
Glib::PropertyProxy< Container* > | property_parent ()
| The parent widget of this widget. More...
Glib::PropertyProxy_ReadOnly< Container* > | property_parent () const
| The parent widget of this widget. More...
Glib::PropertyProxy< int > | property_width_request ()
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_width_request () const
| Override for width request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< int > | property_height_request ()
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy_ReadOnly< int > | property_height_request () const
| Override for height request of the widget, or -1 if natural request should be used. More...
Glib::PropertyProxy< bool > | property_visible ()
| Whether the widget is visible. More...
Glib::PropertyProxy_ReadOnly< bool > | property_visible () const
| Whether the widget is visible. More...
Glib::PropertyProxy< bool > | property_sensitive ()
| Whether the widget responds to input. More...
Glib::PropertyProxy_ReadOnly< bool > | property_sensitive () const
| Whether the widget responds to input. More...
Glib::PropertyProxy< bool > | property_app_paintable ()
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_app_paintable () const
| Whether the application will paint directly on the widget. More...
Glib::PropertyProxy< bool > | property_can_focus ()
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_focus () const
| Whether the widget can accept the input focus. More...
Glib::PropertyProxy< bool > | property_has_focus ()
| Whether the widget has the input focus. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_focus () const
| Whether the widget has the input focus. More...
Glib::PropertyProxy< bool > | property_is_focus ()
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy_ReadOnly< bool > | property_is_focus () const
| Whether the widget is the focus widget within the toplevel. More...
Glib::PropertyProxy< bool > | property_focus_on_click ()
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy_ReadOnly< bool > | property_focus_on_click () const
| Whether the widget should grab focus when it is clicked with the mouse. More...
Glib::PropertyProxy< bool > | property_can_default ()
| Whether the widget can be the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_can_default () const
| Whether the widget can be the default widget. More...
Glib::PropertyProxy< bool > | property_has_default ()
| Whether the widget is the default widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_default () const
| Whether the widget is the default widget. More...
Glib::PropertyProxy< bool > | property_receives_default ()
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_receives_default () const
| If `true`, the widget will receive the default action when it is focused. More...
Glib::PropertyProxy_ReadOnly< bool > | property_composite_child () const
| Whether the widget is part of a composite widget. More...
Glib::PropertyProxy< Glib::RefPtr< Style > > | property_style ()
| The style of the widget, which contains information about how it will look (colors, etc). More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Style > > | property_style () const
| The style of the widget, which contains information about how it will look (colors, etc). More...
Glib::PropertyProxy< Gdk::EventMask > | property_events ()
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy_ReadOnly< Gdk::EventMask > | property_events () const
| The event mask that decides what kind of GdkEvents this widget gets. More...
Glib::PropertyProxy< bool > | property_has_tooltip ()
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_has_tooltip () const
| Enables or disables the emission of Gtk::Widget::signal_query_tooltip() on widget. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_markup ()
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_markup () const
| Sets the text of tooltip to be the given string, which is marked up with the [Pango text markup language][PangoMarkupFormat]. More...
Glib::PropertyProxy< Glib::ustring > | property_tooltip_text ()
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_tooltip_text () const
| Sets the text of tooltip to be the given string. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gdk::Window > > | property_window () const
| The widget's window if it is realized, `nullptr` otherwise. More...
Glib::PropertyProxy< bool > | property_no_show_all ()
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy_ReadOnly< bool > | property_no_show_all () const
| Whether Gtk::Widget::show_all() should not affect this widget. More...
Glib::PropertyProxy< bool > | property_double_buffered ()
| Whether the widget is double buffered. More...
Glib::PropertyProxy_ReadOnly< bool > | property_double_buffered () const
| Whether the widget is double buffered. More...
Glib::PropertyProxy< Align > | property_halign ()
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_halign () const
| How to distribute horizontal space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< Align > | property_valign ()
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy_ReadOnly< Align > | property_valign () const
| How to distribute vertical space if widget gets extra space, see Gtk::Align. More...
Glib::PropertyProxy< int > | property_margin_left ()
| Margin on left side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_left () const
| Margin on left side of widget. More...
Glib::PropertyProxy< int > | property_margin_right ()
| Margin on right side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_right () const
| Margin on right side of widget. More...
Glib::PropertyProxy< int > | property_margin_start ()
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_start () const
| Margin on start of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_end ()
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_end () const
| Margin on end of widget, horizontally. More...
Glib::PropertyProxy< int > | property_margin_top ()
| Margin on top side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_top () const
| Margin on top side of widget. More...
Glib::PropertyProxy< int > | property_margin_bottom ()
| Margin on bottom side of widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin_bottom () const
| Margin on bottom side of widget. More...
Glib::PropertyProxy< int > | property_margin ()
| Sets all four sides' margin at once. More...
Glib::PropertyProxy_ReadOnly< int > | property_margin () const
| Sets all four sides' margin at once. More...
Glib::PropertyProxy< bool > | property_hexpand ()
| Whether to expand horizontally. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand () const
| Whether to expand horizontally. More...
Glib::PropertyProxy< bool > | property_hexpand_set ()
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_hexpand_set () const
| Whether to use the Gtk::Widget::property_hexpand() property. More...
Glib::PropertyProxy< bool > | property_vexpand ()
| Whether to expand vertically. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand () const
| Whether to expand vertically. More...
Glib::PropertyProxy< bool > | property_vexpand_set ()
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy_ReadOnly< bool > | property_vexpand_set () const
| Whether to use the Gtk::Widget::property_vexpand() property. More...
Glib::PropertyProxy< bool > | property_expand ()
| Whether to expand in both directions. More...
Glib::PropertyProxy_ReadOnly< bool > | property_expand () const
| Whether to expand in both directions. More...
Glib::PropertyProxy< double > | property_opacity ()
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< double > | property_opacity () const
| The requested opacity of the widget. More...
Glib::PropertyProxy_ReadOnly< int > | property_scale_factor () const
| The scale factor of the widget. More...
Public Member Functions inherited from Gtk::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gtk::Buildable
| Buildable (Buildable&& src) noexcept
Buildable& | operator= (Buildable&& src) noexcept
| ~Buildable () noexcept override
GtkBuildable* | gobj ()
| Provides access to the underlying C GObject. More...
const GtkBuildable* | gobj () const
| Provides access to the underlying C GObject. More...
void | set_name (const Glib::ustring& name)
| Sets the name of the buildable object. More...
Glib::ustring | get_name () const
| Gets the name of the buildable object. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const
Public Member Functions inherited from Atk::Implementor
| Implementor (Implementor &&src) noexcept
Implementor & | operator= (Implementor &&src) noexcept
| ~Implementor () noexcept override
AtkImplementor * | gobj ()
const AtkImplementor * | gobj () const
Glib::RefPtr< Atk::Implementor > | wrap (AtkImplementor *object, bool take_copy=false)

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::ScrolledWindow
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Bin
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Container
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gtk::Widget
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Widget* | get_current_modal_grab ()
| Retrieve the widget which is currently grabbing all events. More...
static void | push_composite_child ()
| Makes all newly-created widgets as composite children until the corresponding pop_composite_child() call. More...
static void | pop_composite_child ()
| Cancels the effect of a previous call to push_composite_child(). More...
static void | set_default_direction (TextDirection dir)
| Sets the default reading direction for widgets where the direction has not been explicitly set by set_direction(). More...
static TextDirection | get_default_direction ()
| Obtains the current default reading direction. More...
static Widget* | drag_get_source_widget (const Glib::RefPtr< Gdk::DragContext >& context)
Static Public Member Functions inherited from Gtk::Buildable
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Atk::Implementor
static void | add_interface (GType gtype_implementer)
static GType | get_type ()

## Related Functions
(Note that these are not member functions.)
Gtk::PlacesSidebar* | wrap (GtkPlacesSidebar* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::ScrolledWindow
Gtk::ScrolledWindow* | wrap (GtkScrolledWindow* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Bin
Gtk::Bin* | wrap (GtkBin* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Container
Gtk::Container* | wrap (GtkContainer* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Widget
Gtk::Widget* | wrap (GtkWidget* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gtk::Buildable
Glib::RefPtr< Gtk::Buildable > | wrap (GtkBuildable* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Gtk::Container
typedef sigc::slot< void, Widget& > | ForeachSlot
| A slot to invoke with each child iterated over by foreach() or forall(). More...
Public Types inherited from Gtk::Widget
using | SlotTick = sigc::slot< bool(const Glib::RefPtr< Gdk::FrameClock >&)>
| Callback type for adding a function to update animations. More...
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Gtk::Bin
| Bin ()
| This constructor is protected because only derived classes should be instantiated. More...
Protected Member Functions inherited from Gtk::Container
virtual void | on_add (Widget* widget)
| This is a default handler for the signal signal_add(). More...
virtual void | on_remove (Widget* widget)
| This is a default handler for the signal signal_remove(). More...
virtual void | on_check_resize ()
| This is a default handler for the signal signal_check_resize(). More...
virtual void | on_set_focus_child (Widget* widget)
| This is a default handler for the signal signal_set_focus_child(). More...
| Container ()
virtual GType | child_type_vfunc () const
| Implements child_type(). More...
virtual void | forall_vfunc (gboolean include_internals, GtkCallback callback, gpointer callback_data)
| Invokes a callback on all children of the container. More...
virtual char* | composite_name_vfunc (GtkWidget* child)
| Returns the composite name of a child widget. More...
virtual void | set_child_property_vfunc (GtkWidget* child, guint property_id, const GValue* value, GParamSpec* pspec)
| Sets a child property for this container and its child. More...
virtual void | get_child_property_vfunc (GtkWidget* child, guint property_id, GValue* value, GParamSpec* pspec) const
| Returns a child property for this container and its child. More...
Glib::PropertyProxy< guint > | property_border_width ()
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy_ReadOnly< guint > | property_border_width () const
| The width of the empty border outside the containers children. More...
Glib::PropertyProxy< ResizeMode > | property_resize_mode ()
| Specify how resize events are handled. More...
Glib::PropertyProxy_ReadOnly< ResizeMode > | property_resize_mode () const
| Specify how resize events are handled. More...
Glib::PropertyProxy_WriteOnly< Widget* > | property_child ()
| Can be used to add a new child to the container. More...
Protected Member Functions inherited from Gtk::Widget
virtual void | on_show ()
| This is a default handler for the signal signal_show(). More...
virtual void | on_hide ()
| This is a default handler for the signal signal_hide(). More...
virtual void | on_map ()
| This is a default handler for the signal signal_map(). More...
virtual void | on_unmap ()
| This is a default handler for the signal signal_unmap(). More...
virtual void | on_realize ()
| This is a default handler for the signal signal_realize(). More...
virtual void | on_unrealize ()
| This is a default handler for the signal signal_unrealize(). More...
virtual void | on_size_allocate (Allocation& allocation)
| This is a default handler for the signal signal_size_allocate(). More...
virtual void | on_state_changed (Gtk::StateType previous_state)
| This is a default handler for the signal signal_state_changed(). More...
virtual void | on_parent_changed (Widget* previous_parent)
| This is a default handler for the signal signal_parent_changed(). More...
virtual void | on_hierarchy_changed (Widget* previous_toplevel)
| This is a default handler for the signal signal_hierarchy_changed(). More...
virtual void | on_style_updated ()
| This is a default handler for the signal signal_style_updated(). More...
virtual void | on_direction_changed (TextDirection direction)
| This is a default handler for the signal signal_direction_changed(). More...
virtual void | on_grab_notify (bool was_grabbed)
| This is a default handler for the signal signal_grab_notify(). More...
virtual void | on_child_notify (GParamSpec* pspec)
| This is a default handler for the signal signal_child_notify(). More...
virtual bool | on_mnemonic_activate (bool group_cycling)
| This is a default handler for the signal signal_mnemonic_activate(). More...
virtual void | on_grab_focus ()
| This is a default handler for the signal signal_grab_focus(). More...
virtual bool | on_focus (DirectionType direction)
| This is a default handler for the signal signal_focus(). More...
virtual bool | on_event (GdkEvent* gdk_event)
| This is a default handler for the signal signal_event(). More...
virtual bool | on_button_press_event (GdkEventButton* button_event)
| This is a default handler for the signal signal_button_press_event(). More...
virtual bool | on_button_release_event (GdkEventButton* release_event)
| This is a default handler for the signal signal_button_release_event(). More...
virtual bool | on_scroll_event (GdkEventScroll* scroll_event)
| This is a default handler for the signal signal_scroll_event(). More...
virtual bool | on_motion_notify_event (GdkEventMotion* motion_event)
| This is a default handler for the signal signal_motion_notify_event(). More...
virtual bool | on_delete_event (GdkEventAny* any_event)
| This is a default handler for the signal signal_delete_event(). More...
virtual bool | on_draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| This is a default handler for the signal signal_draw(). More...
virtual bool | on_key_press_event (GdkEventKey* key_event)
| This is a default handler for the signal signal_key_press_event(). More...
virtual bool | on_key_release_event (GdkEventKey* key_event)
| This is a default handler for the signal signal_key_release_event(). More...
virtual bool | on_enter_notify_event (GdkEventCrossing* crossing_event)
| This is a default handler for the signal signal_enter_notify_event(). More...
virtual bool | on_leave_notify_event (GdkEventCrossing* crossing_event)
| This is a default handler for the signal signal_leave_notify_event(). More...
virtual bool | on_configure_event (GdkEventConfigure* configure_event)
| This is a default handler for the signal signal_configure_event(). More...
virtual bool | on_focus_in_event (GdkEventFocus* focus_event)
| This is a default handler for the signal signal_focus_in_event(). More...
virtual bool | on_focus_out_event (GdkEventFocus* gdk_event)
| This is a default handler for the signal signal_focus_out_event(). More...
virtual bool | on_map_event (GdkEventAny* any_event)
| This is a default handler for the signal signal_map_event(). More...
virtual bool | on_unmap_event (GdkEventAny* any_event)
| This is a default handler for the signal signal_unmap_event(). More...
virtual bool | on_property_notify_event (GdkEventProperty* property_event)
| This is a default handler for the signal signal_property_notify_event(). More...
virtual bool | on_selection_clear_event (GdkEventSelection* selection_event)
| This is a default handler for the signal signal_selection_clear_event(). More...
virtual bool | on_selection_request_event (GdkEventSelection* selection_event)
| This is a default handler for the signal signal_selection_request_event(). More...
virtual bool | on_selection_notify_event (GdkEventSelection* selection_event)
| This is a default handler for the signal signal_selection_notify_event(). More...
virtual bool | on_proximity_in_event (GdkEventProximity* proximity_event)
| This is a default handler for the signal signal_proximity_in_event(). More...
virtual bool | on_proximity_out_event (GdkEventProximity* proximity_event)
| This is a default handler for the signal signal_proximity_out_event(). More...
virtual bool | on_visibility_notify_event (GdkEventVisibility* visibility_event)
| This is a default handler for the signal signal_visibility_notify_event(). More...
virtual bool | on_window_state_event (GdkEventWindowState* window_state_event)
| This is a default handler for the signal signal_window_state_event(). More...
virtual void | on_selection_get (SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_selection_get(). More...
virtual void | on_selection_received (const SelectionData& selection_data, guint time)
| This is a default handler for the signal signal_selection_received(). More...
virtual void | on_drag_begin (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_begin(). More...
virtual void | on_drag_end (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_end(). More...
virtual void | on_drag_data_get (const Glib::RefPtr< Gdk::DragContext >& context, SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_get(). More...
virtual void | on_drag_data_delete (const Glib::RefPtr< Gdk::DragContext >& context)
| This is a default handler for the signal signal_drag_data_delete(). More...
virtual void | on_drag_leave (const Glib::RefPtr< Gdk::DragContext >& context, guint time)
| This is a default handler for the signal signal_drag_leave(). More...
virtual bool | on_drag_motion (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_motion(). More...
virtual bool | on_drag_drop (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, guint time)
| This is a default handler for the signal signal_drag_drop(). More...
virtual void | on_drag_data_received (const Glib::RefPtr< Gdk::DragContext >& context, int x, int y, const SelectionData& selection_data, guint info, guint time)
| This is a default handler for the signal signal_drag_data_received(). More...
virtual void | on_screen_changed (const Glib::RefPtr< Gdk::Screen >& previous_screen)
| This is a default handler for the signal signal_screen_changed(). More...
virtual void | dispatch_child_properties_changed_vfunc (guint p1, GParamSpec** p2)
virtual void | show_all_vfunc ()
virtual Glib::RefPtr< Atk::Object > | get_accessible_vfunc ()
virtual SizeRequestMode | get_request_mode_vfunc () const
virtual void | get_preferred_width_vfunc (int& minimum_width, int& natural_width) const
virtual void | get_preferred_height_for_width_vfunc (int width, int& minimum_height, int& natural_height) const
virtual void | get_preferred_height_vfunc (int& minimum_height, int& natural_height) const
virtual void | get_preferred_width_for_height_vfunc (int height, int& minimum_width, int& natural_width) const
| Widget ()
void | realize ()
| Creates the GDK (windowing system) resources associated with a widget. More...
void | unrealize ()
| This function is only useful in widget implementations. More...
void | draw (const ::Cairo::RefPtr< ::Cairo::Context >& cr)
| Draws widget to cr. More...
void | set_mapped (bool mapped=true)
| Marks the widget as being mapped. More...
void | set_realized (bool realized=true)
| Marks the widget as being realized. More...
void | set_has_window (bool has_window=true)
| Specifies whether widget has a Gdk::Window of its own. More...
void | set_window (const Glib::RefPtr< Gdk::Window >& window)
| Sets a widget's window. More...
void | transform_cairo_context_to_window (const ::Cairo::RefPtr< ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| Transforms the given cairo context cr from widget-relative coordinates to window-relative coordinates. More...
Requisition | get_requisition () const
| Retrieves the widget's requisition. More...
void | get_style_property_value (const Glib::ustring& the_property_name, Glib::ValueBase& value) const
| Gets the value of a style property of widget. More...
void | realize_if_needed ()
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gtk::Buildable
| Buildable ()
| You should derive from this class to use it. More...
Protected Member Functions inherited from Atk::Implementor
| Implementor ()
virtual Glib::RefPtr< Object > | ref_accessibile_vfunc ()
Static Protected Member Functions inherited from Gtk::Widget
static bool | should_draw_window (const ::Cairo::RefPtr< const ::Cairo::Context >& cr, const Glib::RefPtr< const Gdk::Window >& window)
| This function is supposed to be called in Gtk::Widget::signal_draw() implementations for widgets that support multiple windows. More...

## Detailed Description

Sidebar that displays frequently-used places in the file system.

Gtk::PlacesSidebar is a widget that displays a list of frequently-used places in the file system: the user's home directory, the user's bookmarks, and volumes and drives. This widget is used as a sidebar in Gtk::FileChooser and may be used by file managers and similar programs.

The places sidebar displays drives and volumes, and will automatically mount or unmount them when the user selects them.

Applications can hook to various signals in the places sidebar to customize its behavior. For example, they can add extra commands to the context menu of the sidebar.

While bookmarks are completely in control of the user, the places sidebar also allows individual applications to provide extra shortcut folders that are unique to each application. For example, a Paint program may want to add a shortcut for a Clipart folder. You can do this with Gtk::PlacesSidebar::add_shortcut().

To make use of the places sidebar, an application at least needs to connect to the Gtk::PlacesSidebar::open-location signal. This is emitted when the user selects in the sidebar a location to open. The application should also call Gtk::PlacesSidebar::set_location() when it changes the currently-viewed location.

Since gtkmm 3.10:

## Constructor & Destructor Documentation

## ◆ PlacesSidebar() [1/3]

Gtk::PlacesSidebar::PlacesSidebar | ( | PlacesSidebar&& | src | ) |
| noexcept

## ◆ PlacesSidebar() [2/3]

Gtk::PlacesSidebar::PlacesSidebar | ( | const PlacesSidebar& |  | ) |
| delete

## ◆ ~PlacesSidebar()

Gtk::PlacesSidebar::~PlacesSidebar | ( |  | ) |
| overridenoexcept

## ◆ PlacesSidebar() [3/3]

Gtk::PlacesSidebar::PlacesSidebar | ( |  | ) |

Creates a new Gtk::PlacesSidebar widget.

The application should connect to at least the "open-location" signal to be notified when the user makes a selection in the sidebar.

## Member Function Documentation

## ◆ add_shortcut()

void Gtk::PlacesSidebar::add_shortcut | ( | const Glib::RefPtr< Gio::File > & | location | ) |

Applications may want to present some folders in the places sidebar if they could be immediately useful to users.

For example, a drawing program could add a “/usr/share/clipart” location when the sidebar is being used in an “Insert Clipart” dialog box.

This function adds the specified location to a special place for immutable shortcuts. The shortcuts are application-specific; they are not shared across applications, and they are not persistent. If this function is called multiple times with different locations, then they are added to the sidebar’s list in the same order as the function is called.

Since gtkmm 3.10:

Parameters

  location | Location to add as an application-specific shortcut.

## ◆ get_local_only()

bool Gtk::PlacesSidebar::get_local_only | ( |  | ) | const

Returns the value previously set with set_local_only().

Since gtkmm 3.12:

Returns
  `true` if the sidebar will only show local files.

## ◆ get_location()

Glib::RefPtr<Gio::File> Gtk::PlacesSidebar::get_location | ( |  | ) | const

Gets the currently selected location in the sidebar.

This can be `nullptr` when nothing is selected, for example, when set_location() has been called with a location that is not among the sidebar’s list of places to show.

You can use this function to get the selection in the sidebar. Also, if you connect to the Gtk::PlacesSidebar::signal_populate_popup() signal, you can use this function to get the location that is being referred to during the callbacks for your menu items.

Since gtkmm 3.10:

Returns
  A Gio::File with the selected location, or `nullptr` if nothing is visually selected.

## ◆ get_nth_bookmark()

Glib::RefPtr<Gio::File> Gtk::PlacesSidebar::get_nth_bookmark | ( | int | n | ) | const

This function queries the bookmarks added by the user to the places sidebar, and returns one of them.

This function is used by Gtk::FileChooser to implement the “Alt-1”, “Alt-2”, etc. shortcuts, which activate the cooresponding bookmark.

Since gtkmm 3.10:

Parameters

  n | Index of the bookmark to query.

Returns
  The bookmark specified by the index n, or `nullptr` if no such index exist. Note that the indices start at 0, even though the file chooser starts them with the keyboard shortcut "Alt-1".

## ◆ get_open_flags()

PlacesOpenFlags Gtk::PlacesSidebar::get_open_flags | ( |  | ) | const

Gets the open flags.

Since gtkmm 3.10:

Returns
  The Gtk::PlacesOpenFlags of sidebar.

## ◆ get_show_connect_to_server()

bool Gtk::PlacesSidebar::get_show_connect_to_server | ( |  | ) | const

Returns the value previously set with set_show_connect_to_server()

Deprecated: 3.18: It is recommended to group this functionality with the drives and network location under the new 'Other Location' item

Deprecated:
  It is recommended to group this functionality with the drives and network location under the new 'Other Location' item.

Returns
  `true` if the sidebar will display a “Connect to Server” item.

## ◆ get_show_desktop()

bool Gtk::PlacesSidebar::get_show_desktop | ( |  | ) | const

Returns the value previously set with set_show_desktop()

Since gtkmm 3.10:

Returns
  `true` if the sidebar will display a builtin shortcut to the desktop folder.

## ◆ get_show_enter_location()

bool Gtk::PlacesSidebar::get_show_enter_location | ( |  | ) | const

Returns the value previously set with set_show_enter_location()

Since gtkmm 3.14:

Returns
  `true` if the sidebar will display an “Enter Location” item.

## ◆ get_show_other_locations()

bool Gtk::PlacesSidebar::get_show_other_locations | ( |  | ) | const

Returns the value previously set with set_show_other_locations()

Since gtkmm 3.18:

Returns
  `true` if the sidebar will display an “Other Locations” item.

## ◆ get_show_recent()

bool Gtk::PlacesSidebar::get_show_recent | ( |  | ) | const

Returns the value previously set with set_show_recent()

Since gtkmm 3.18:

Returns
  `true` if the sidebar will display a builtin shortcut for recent files.

## ◆ get_show_trash()

bool Gtk::PlacesSidebar::get_show_trash | ( |  | ) | const

Returns the value previously set with set_show_trash()

Since gtkmm 3.18:

Returns
  `true` if the sidebar will display a “Trash” item.

## ◆ get_type()

static GType Gtk::PlacesSidebar::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GtkPlacesSidebar* Gtk::PlacesSidebar::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GtkPlacesSidebar* Gtk::PlacesSidebar::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ list_shortcuts()

std::vector< Glib::RefPtr<Gio::File> > Gtk::PlacesSidebar::list_shortcuts | ( |  | ) | const

Gets the list of shortcuts.

Since gtkmm 3.10:

Returns
  A SList of Gio::File of the locations that have been added as application-specific shortcuts with add_shortcut(). To free this list, you can use

[C example ellipted].

## ◆ operator=() [1/2]

PlacesSidebar& Gtk::PlacesSidebar::operator= | ( | PlacesSidebar&& | src | ) |
| noexcept

## ◆ operator=() [2/2]

PlacesSidebar& Gtk::PlacesSidebar::operator= | ( | const PlacesSidebar& |  | ) |
| delete

## ◆ property_local_only() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_local_only | ( |  | ) |

Whether the sidebar only includes local files.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_local_only() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_local_only | ( |  | ) | const

Whether the sidebar only includes local files.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_location() [1/2]

Glib::PropertyProxy< Glib::RefPtr<Gio::File> > Gtk::PlacesSidebar::property_location | ( |  | ) |

The location to highlight in the sidebar.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_location() [2/2]

Glib::PropertyProxy_ReadOnly< Glib::RefPtr<Gio::File> > Gtk::PlacesSidebar::property_location | ( |  | ) | const

The location to highlight in the sidebar.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_open_flags() [1/2]

Glib::PropertyProxy< PlacesOpenFlags > Gtk::PlacesSidebar::property_open_flags | ( |  | ) |

Modes in which the calling application can open locations selected in the sidebar.

Default value: Gtk::PLACES_OPEN_NORMAL

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_open_flags() [2/2]

Glib::PropertyProxy_ReadOnly< PlacesOpenFlags > Gtk::PlacesSidebar::property_open_flags | ( |  | ) | const

Modes in which the calling application can open locations selected in the sidebar.

Default value: Gtk::PLACES_OPEN_NORMAL

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_populate_all() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_populate_all | ( |  | ) |

If :populate-all is `true`, the Gtk::PlacesSidebar::signal_populate_popup() signal is also emitted for popovers.

Since gtkmm 3.18:

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_populate_all() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_populate_all | ( |  | ) | const

If :populate-all is `true`, the Gtk::PlacesSidebar::signal_populate_popup() signal is also emitted for popovers.

Since gtkmm 3.18:

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_connect_to_server() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_connect_to_server | ( |  | ) |

Whether the sidebar includes a builtin shortcut to a 'Connect to server' dialog.

Deprecated:
  Use property_show_other_locations() instead.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_connect_to_server() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_connect_to_server | ( |  | ) | const

Whether the sidebar includes a builtin shortcut to a 'Connect to server' dialog.

Deprecated:
  Use property_show_other_locations() instead.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_desktop() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_desktop | ( |  | ) |

Whether the sidebar includes a builtin shortcut to the Desktop folder.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_desktop() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_desktop | ( |  | ) | const

Whether the sidebar includes a builtin shortcut to the Desktop folder.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_enter_location() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_enter_location | ( |  | ) |

Whether the sidebar includes a builtin shortcut to manually enter a location.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_enter_location() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_enter_location | ( |  | ) | const

Whether the sidebar includes a builtin shortcut to manually enter a location.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_other_locations() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_other_locations | ( |  | ) |

Whether the sidebar includes an item to show external locations.

Default value: `false`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_other_locations() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_other_locations | ( |  | ) | const

Whether the sidebar includes an item to show external locations.

Default value: `false`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_recent() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_recent | ( |  | ) |

Whether the sidebar includes a builtin shortcut for recent files.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_recent() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_recent | ( |  | ) | const

Whether the sidebar includes a builtin shortcut for recent files.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_trash() [1/2]

Glib::PropertyProxy< bool > Gtk::PlacesSidebar::property_show_trash | ( |  | ) |

Whether the sidebar includes a builtin shortcut to the Trash location.

Default value: `true`

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_show_trash() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gtk::PlacesSidebar::property_show_trash | ( |  | ) | const

Whether the sidebar includes a builtin shortcut to the Trash location.

Default value: `true`

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ remove_shortcut()

void Gtk::PlacesSidebar::remove_shortcut | ( | const Glib::RefPtr< Gio::File > & | location | ) |

Removes an application-specific shortcut that has been previously been inserted with add_shortcut().

If the location is not a shortcut in the sidebar, then nothing is done.

Since gtkmm 3.10:

Parameters

  location | Location to remove.

## ◆ set_drop_targets_visible()

void Gtk::PlacesSidebar::set_drop_targets_visible | ( | bool | visible,
|  | const Glib::RefPtr< Gdk::DragContext >& | context
| ) |  |

Make the GtkPlacesSidebar show drop targets, so it can show the available drop targets and a "new bookmark" row.

This improves the Drag-and-Drop experience of the user and allows applications to show all available drop targets at once.

This needs to be called when the application is aware of an ongoing drag that might target the sidebar. The drop-targets-visible state will be unset automatically if the drag finishes in the GtkPlacesSidebar. You only need to unset the state when the drag ends on some other widget on your application.

Since gtkmm 3.18:

Parameters

  visible | Whether to show the valid targets or not.
  context | Drag context used to ask the source about the action that wants to perform, so hints are more accurate.

## ◆ set_local_only()

void Gtk::PlacesSidebar::set_local_only | ( | bool | local_only = `true` | ) |

Sets whether the sidebar should only show local files.

Since gtkmm 3.12:

Parameters

  local_only | Whether to show only local files.

## ◆ set_location()

void Gtk::PlacesSidebar::set_location | ( | const Glib::RefPtr< const Gio::File > & | location | ) |

Sets the location that is being shown in the widgets surrounding the sidebar, for example, in a folder view in a file manager.

In turn, the sidebar will highlight that location if it is being shown in the list of places, or it will unhighlight everything if the location is not among the places in the list.

Since gtkmm 3.10:

Parameters

  location | Location to select, or `nullptr` for no current path.

## ◆ set_open_flags()

void Gtk::PlacesSidebar::set_open_flags | ( | PlacesOpenFlags | flags = `PLACES_OPEN_NORMAL` | ) |

Sets the way in which the calling application can open new locations from the places sidebar.

For example, some applications only open locations “directly” into their main view, while others may support opening locations in a new notebook tab or a new window.

This function is used to tell the places sidebar about the ways in which the application can open new locations, so that the sidebar can display (or not) the “Open in new tab” and “Open in new window” menu items as appropriate.

When the Gtk::PlacesSidebar::signal_open_location() signal is emitted, its flags argument will be set to one of the flags that was passed in set_open_flags().

Passing 0 for flags will cause Gtk::PLACES_OPEN_NORMAL to always be sent to callbacks for the “open-location” signal.

Since gtkmm 3.10:

Parameters

  flags | Bitmask of modes in which the calling application can open locations.

## ◆ set_show_connect_to_server()

void Gtk::PlacesSidebar::set_show_connect_to_server | ( | bool | show_connect_to_server = `true` | ) |

Sets whether the sidebar should show an item for connecting to a network server; this is off by default.

An application may want to turn this on if it implements a way for the user to connect to network servers directly.

If you enable this, you should connect to the Gtk::PlacesSidebar::signal_show_connect_to_server() signal.

Since gtkmm 3.10:

Deprecated: 3.18: It is recommended to group this functionality with the drives and network location under the new 'Other Location' item

Deprecated:
  It is recommended to group this functionality with the drives and network location under the new 'Other Location' item.

Parameters

  show_connect_to_server | Whether to show an item for the Connect to Server command.

## ◆ set_show_desktop()

void Gtk::PlacesSidebar::set_show_desktop | ( | bool | show_desktop = `true` | ) |

Sets whether the sidebar should show an item for the Desktop folder.

The default value for this option is determined by the desktop environment and the user’s configuration, but this function can be used to override it on a per-application basis.

Since gtkmm 3.10:

Parameters

  show_desktop | Whether to show an item for the Desktop folder.

## ◆ set_show_enter_location()

void Gtk::PlacesSidebar::set_show_enter_location | ( | bool | show_enter_location = `true` | ) |

Sets whether the sidebar should show an item for entering a location; this is off by default.

An application may want to turn this on if manually entering URLs is an expected user action.

If you enable this, you should connect to the Gtk::PlacesSidebar::signal_show_enter_location() signal.

Since gtkmm 3.14:

Parameters

  show_enter_location | Whether to show an item to enter a location.

## ◆ set_show_other_locations()

void Gtk::PlacesSidebar::set_show_other_locations | ( | bool | show_other_locations = `true` | ) |

Sets whether the sidebar should show an item for the application to show an Other Locations view; this is off by default.

When set to `true`, persistent devices such as hard drives are hidden, otherwise they are shown in the sidebar. An application may want to turn this on if it implements a way for the user to see and interact with drives and network servers directly.

If you enable this, you should connect to the Gtk::PlacesSidebar::signal_show_other_locations() signal.

Since gtkmm 3.18:

Parameters

  show_other_locations | Whether to show an item for the Other Locations view.

## ◆ set_show_recent()

void Gtk::PlacesSidebar::set_show_recent | ( | bool | show_recent = `true` | ) |

Sets whether the sidebar should show an item for recent files.

The default value for this option is determined by the desktop environment, but this function can be used to override it on a per-application basis.

Since gtkmm 3.18:

Parameters

  show_recent | Whether to show an item for recent files.

## ◆ set_show_trash()

void Gtk::PlacesSidebar::set_show_trash | ( | bool | show_trash = `true` | ) |

Sets whether the sidebar should show an item for the Trash location.

Since gtkmm 3.18:

Parameters

  show_trash | Whether to show an item for the Trash location.

## ◆ signal_drag_action_ask()

Glib::SignalProxy< int,int > Gtk::PlacesSidebar::signal_drag_action_ask | ( |  | ) |

Slot Prototype:
  `int on_my_drag_action_ask(int actions)`

Flags: Run Last

The places sidebar emits this signal when it needs to ask the application to pop up a menu to ask the user for which drag action to perform.

Since gtkmm 3.10:

Parameters

  actions | Possible drag actions that need to be asked for.

Returns
  The final drag action that the sidebar should pass to the drag side of the drag-and-drop operation.

## ◆ signal_drag_action_requested()

Glib::SignalProxy< int,const Glib::RefPtr<Gdk::DragContext>&,const Glib::RefPtr<Gio::File>&,const std::vector< Glib::RefPtr<Gio::File> >& > Gtk::PlacesSidebar::signal_drag_action_requested | ( |  | ) |

Slot Prototype:
  `int on_my_drag_action_requested(const Glib::RefPtr<Gdk::DragContext>& context, const Glib::RefPtr<Gio::File>& dest_file, const std::vector< Glib::RefPtr<Gio::File> >& source_file_list)`

Flags: Run Last

When the user starts a drag-and-drop operation and the sidebar needs to ask the application for which drag action to perform, then the sidebar will emit this signal.

The application can evaluate the context for customary actions, or it can check the type of the files indicated by source_file_list against the possible actions for the destination dest_file.

The drag action to use must be the return value of the signal handler.

Since gtkmm 3.10:

Parameters

  context | Gdk::DragContext with information about the drag operation.
  dest_file | Gio::File with the tentative location that is being hovered for a drop.
  source_file_list | List of Gio::File that are being dragged.

Returns
  The drag action to use, for example, Gdk::ACTION_COPY or Gdk::ACTION_MOVE, or 0 if no action is allowed here (i.e. drops are not allowed in the specified dest_file).

## ◆ signal_drag_perform_drop()

Glib::SignalProxy< void,const Glib::RefPtr<Gio::File>&,const std::vector< Glib::RefPtr<Gio::File> >&,int > Gtk::PlacesSidebar::signal_drag_perform_drop | ( |  | ) |

Slot Prototype:
  `void on_my_drag_perform_drop(const Glib::RefPtr<Gio::File>& dest_file, const std::vector< Glib::RefPtr<Gio::File> >& source_file_list, int action)`

Flags: Run First

The places sidebar emits this signal when the user completes a drag-and-drop operation and one of the sidebar's items is the destination. This item is in the dest_file, and the source_file_list has the list of files that are dropped into it and which should be copied/moved/etc. based on the specified action.

Since gtkmm 3.10:

Parameters

  dest_file | Destination Gio::File.
  source_file_list | List of Gio::File that got dropped.
  action | Drop action to perform.

## ◆ signal_mount()

Glib::SignalProxy< void,const Glib::RefPtr<Gio::MountOperation>& > Gtk::PlacesSidebar::signal_mount | ( |  | ) |

Slot Prototype:
  `void on_my_mount(const Glib::RefPtr<Gio::MountOperation>& mount_operation)`

Flags: Run First

The places sidebar emits this signal when it starts a new operation because the user clicked on some location that needs mounting. In this way the application using the Gtk::PlacesSidebar can track the progress of the operation and, for example, show a notification.

Since gtkmm 3.20:

Parameters

  mount_operation | The Gio::MountOperation that is going to start.

## ◆ signal_open_location()

Glib::SignalProxy< void,const Glib::RefPtr<Gio::File>&,PlacesOpenFlags > Gtk::PlacesSidebar::signal_open_location | ( |  | ) |

Slot Prototype:
  `void on_my_open_location(const Glib::RefPtr<Gio::File>& location, PlacesOpenFlags open_flags)`

Flags: Run First

The places sidebar emits this signal when the user selects a location in it. The calling application should display the contents of that location; for example, a file manager should show a list of files in the specified location.

Since gtkmm 3.10:

Parameters

  location | Gio::File to which the caller should switch.
  open_flags | A single value from Gtk::PlacesOpenFlags specifying how the location should be opened.

## ◆ signal_populate_popup()

Glib::SignalProxy< void,Menu*,const Glib::RefPtr<Gio::File>&,const Glib::RefPtr<Gio::Volume>& > Gtk::PlacesSidebar::signal_populate_popup | ( |  | ) |

Slot Prototype:
  `void on_my_populate_popup(Menu* menu, const Glib::RefPtr<Gio::File>& selected_item, const Glib::RefPtr<Gio::Volume>& selected_volume)`

Flags: Run First

The places sidebar emits this signal when the user invokes a contextual popup on one of its items. In the signal handler, the application may add extra items to the menu as appropriate. For example, a file manager may want to add a "Properties" command to the menu.

It is not necessary to store the selected_item for each menu item; during their callbacks, the application can use Gtk::PlacesSidebar::get_location() to get the file to which the item refers.

The selected_item argument may be `nullptr` in case the selection refers to a volume. In this case, selected_volume will be non-`nullptr`. In this case, the calling application will have to Glib::object_ref() the selected_volume and keep it around to use it in the callback.

The menu and all its contents are destroyed after the user dismisses the popup. The popup is re-created (and thus, this signal is emitted) every time the user activates the contextual menu.

Before 3.18, the menu always was a Gtk::Menu, and you were expected to add your items as Gtk::MenuItems. Since 3.18, the popup may be implemented as a Gtk::Popover, in which case menu will be something else, e.g. a Gtk::Box, to which you may add Gtk::ModelButtons or other widgets, such as Gtk::Entries, Gtk::SpinButtons, etc. If your application can deal with this situation, you can set Gtk::PlacesSidebar::signal_populate_all() to `true` to request that this signal is emitted for populating popovers as well.

Since gtkmm 3.10:

Parameters

  menu | A Gtk::Menu or another Gtk::Container.
  selected_item | Gio::File with the item to which the popup should refer, or `nullptr` in the case of a selected_volume.
  selected_volume | Gio::Volume if the selected item is a volume, or `nullptr` if it is a file.

## ◆ signal_show_connect_to_server()

Glib::SignalProxy< void > Gtk::PlacesSidebar::signal_show_connect_to_server | ( |  | ) |

Slot Prototype:
  `void on_my_show_connect_to_server()`

Flags: Run First

The places sidebar emits this signal when it needs the calling application to present an way to connect directly to a network server. For example, the application may bring up a dialog box asking for a URL like "sftp://ftp.example.com". It is up to the application to create the corresponding mount by using, for example, Glib::file_mount_enclosing_volume().

Deprecated: 3.18: use the Gtk::PlacesSidebar::signal_show_other_locations() signal to connect to network servers.

Deprecated:
  Use signal_show_other_locations() to connect to network servers.

## ◆ signal_show_enter_location()

Glib::SignalProxy< void > Gtk::PlacesSidebar::signal_show_enter_location | ( |  | ) |

Slot Prototype:
  `void on_my_show_enter_location()`

Flags: Run First

The places sidebar emits this signal when it needs the calling application to present an way to directly enter a location. For example, the application may bring up a dialog box asking for a URL like "http://http.example.com".

Since gtkmm 3.14:

## ◆ signal_show_error_message()

Glib::SignalProxy< void,const Glib::ustring&,const Glib::ustring& > Gtk::PlacesSidebar::signal_show_error_message | ( |  | ) |

Slot Prototype:
  `void on_my_show_error_message(const Glib::ustring& primary, const Glib::ustring& secondary)`

Flags: Run First

The places sidebar emits this signal when it needs the calling application to present an error message. Most of these messages refer to mounting or unmounting media, for example, when a drive cannot be started for some reason.

Since gtkmm 3.10:

Parameters

  primary | Primary message with a summary of the error to show.
  secondary | Secondary message with details of the error to show.

## ◆ signal_show_other_locations()

Glib::SignalProxy< void > Gtk::PlacesSidebar::signal_show_other_locations | ( |  | ) |

Slot Prototype:
  `void on_my_show_other_locations()`

Flags: Run First

The places sidebar emits this signal when it needs the calling application to present a way to show other locations e.g. drives and network access points. For example, the application may bring up a page showing persistent volumes and discovered network addresses.

Deprecated: 3.20: use the Gtk::PlacesSidebar::signal_show_other_locations_with_flags() which includes the open flags in order to allow the user to specify to open in a new tab or window, in a similar way than Gtk::PlacesSidebar::signal_open_location()

Since gtkmm 3.18:

Deprecated:
  Use signal_show_other_locations_with_flags() instead.

## ◆ signal_show_other_locations_with_flags()

Glib::SignalProxy< void,PlacesOpenFlags > Gtk::PlacesSidebar::signal_show_other_locations_with_flags | ( |  | ) |

Slot Prototype:
  `void on_my_show_other_locations_with_flags(PlacesOpenFlags open_flags)`

Flags: Run First

The places sidebar emits this signal when it needs the calling application to present a way to show other locations e.g. drives and network access points. For example, the application may bring up a page showing persistent volumes and discovered network addresses.

Since gtkmm 3.20:

Parameters

  open_flags | A single value from Gtk::PlacesOpenFlags specifying how it should be opened.

## ◆ signal_unmount()

Glib::SignalProxy< void,const Glib::RefPtr<Gio::MountOperation>& > Gtk::PlacesSidebar::signal_unmount | ( |  | ) |

Slot Prototype:
  `void on_my_unmount(const Glib::RefPtr<Gio::MountOperation>& mount_operation)`

Flags: Run First

The places sidebar emits this signal when it starts a new operation because the user for example ejected some drive or unmounted a mount. In this way the application using the Gtk::PlacesSidebar can track the progress of the operation and, for example, show a notification.

Since gtkmm 3.20:

Parameters

  mount_operation | The Gio::MountOperation that is going to start.

## Friends And Related Function Documentation

## ◆ wrap()

Gtk::PlacesSidebar* wrap | ( | GtkPlacesSidebar * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.